package net.pricefx.formulaengine.optimization;

import java.util.Map;

/**
 * The {@link ModelCalculationFormulaContext} is exposed to model calculation logics through the <code>model</code> binding.
 * <p>
 * It contains read and write operations, contrary to {@link ModelEvaluationFormulaContext}.
 */
public interface ModelCalculationFormulaContext extends ModelFormulaContextReadWrite {
    final class ForFormulaDeployment implements ModelCalculationFormulaContext {
        @Override
        public String uniqueName() {
            return null;
        }

        @Override
        public String label() {
            return null;
        }

        @Override
        public Map<String, Object> state() {
            return Map.of();
        }

        @Override
        public Object table(String name) {
            return null;
        }

        @Override
        public void startJobTriggerCalculation(String imageName, String imageTag, String parameters, String calculationContext) {
            // noop
        }

        @Override
        public Object addTable(String name, Map<String, Object> tableSpecs) {
            return null;
        }

        @Override
        public long loadTable(Object table, Object source, boolean truncate) {
            return 0;
        }

        @Override
        public void truncateTable(Object table) {
            // noop
        }

        @Override
        public void dropTable(Object table) {
            // noop
        }
    }
}
